/***************************************************************************
 *   Copyright (C) 2005 by Joel R. Voss                                    *
 *   jvoss@myuw.net                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef NEURAL_H_
#define NEURAL_H_

#ifndef TYPES_H_
#define TYPES_H_
typedef unsigned char  BYTE;	// Hoping in all cases that byte  is  8-bits.
typedef unsigned short WORD;	// Hoping in all cases that short is 16-bits.
typedef   signed short SHORT;	// Hoping in all cases that short is 16-bits.

#endif // TYPES_H_

enum NeuralInput {
	false = 0, true = 1
};
typedef enum NeuralInput NeuralInput;
typedef NeuralInput NeuralOutput;

struct NeuralNode {
	WORD  num_weights;
	SHORT *weights;
	SHORT bias;
};
typedef struct NeuralNode NeuralNode;

struct NeuralLayer {
	WORD num_nodes;
	NeuralNode *nodes;
};
typedef struct NeuralLayer NeuralLayer;

struct NeuralNetwork {
	WORD  id;
	char *name;
	WORD num_layers;
	NeuralLayer *data;
};
typedef struct NeuralNetwork NeuralNetwork;

void NeuralNetwork_init(NeuralNetwork *net, WORD layers, WORD nodes);
void NeuralNetwork_destroy(NeuralNetwork *net);
NeuralInput *NeuralNetwork_update(NeuralNetwork *net, NeuralInput *input);

void NeuralLayer_init(NeuralLayer *layer, WORD nodes);
void NeuralLayer_destroy(NeuralLayer *layer);
NeuralInput *NeuralLayer_update(NeuralLayer *layer, NeuralInput *input);

void NeuralNode_init(NeuralNode *node, WORD weights);
void NeuralNode_destroy(NeuralNode *node);
NeuralInput NeuralNode_update(NeuralNode *node, NeuralInput *input);

#endif // NEURAL_H_
