/***************************************************************************
 *   Copyright (C) 2005 by Joel R. Voss                                    *
 *   jvoss@myuw.net                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include "robotcat.h"
#include "gtkgui.h"

int main(int argc, char *argv[])
{
	printf("Robot Cat\n");
	
	// The Robot Cat object.
	RobotCat cat;
	
	// Manually initialize in C.
	RobotCat_init(&cat, 10, 3);
	
	if(argc > 1 && strcmp("-d", argv[1]) == 0)
	{
		// Use the Command-line interface
	}
	else
	{
		// Use the GUI
		// The gui is a nice tamagotchi interface.
		gui_main(argc, argv, &cat);
	}
	
	// Manually destroy in C. If gtk_main is called, gtk's destroy must call RobotCat_destroy.
	RobotCat_destroy(&cat);
	
	return 0;
}
